import { Base, Type } from "./type";
import { IComponentRendererAdapter } from "./IComponentRendererAdapter";
import { TypeDescriptionContext } from "./TypeDescriptionContext";
import { ITypeDescriptionPropertyTransforms } from "./ITypeDescriptionPropertyTransforms";
import { TypeDescriptionCleanups } from "./TypeDescriptionCleanups";
import { Dictionary$2 } from "./Dictionary$2";
import { Description } from "./Description";
import { DescriptionTreeNode } from "./DescriptionTreeNode";
import { DescriptionRef } from "./DescriptionRef";
import { TypeDescriptionPlatform } from "./TypeDescriptionPlatform";
import { JsonDictionaryItem } from "./JsonDictionaryItem";
import { DescriptionRefTargetInfo } from "./DescriptionRefTargetInfo";
/**
 * @hidden
 */
export declare class ComponentRenderer extends Base {
    static $t: Type;
    private static _defaultInstance;
    static get defaultInstance(): ComponentRenderer;
    static set defaultInstance(a: ComponentRenderer);
    private _adapter;
    get adapter(): IComponentRendererAdapter;
    set adapter(a: IComponentRendererAdapter);
    private _context;
    get context(): TypeDescriptionContext;
    set context(a: TypeDescriptionContext);
    private _isProceedOnErrorEnabled;
    get isProceedOnErrorEnabled(): boolean;
    set isProceedOnErrorEnabled(a: boolean);
    i: ITypeDescriptionPropertyTransforms;
    j: TypeDescriptionCleanups;
    static platform: TypeDescriptionPlatform;
    constructor();
    private h;
    toJson(a: (arg1: any) => string): string;
    private df;
    private dg;
    private w;
    private t;
    private de;
    private n;
    createObjectFromJson(a: string, b: any): any;
    loadJson(a: string, b: (arg1: string) => any): void;
    loadJsonOverlay(a: string, b: (arg1: string) => any, c: (arg1: string) => any): void;
    loadJsonDelta(a: string, b: (arg1: string) => any, c: boolean): void;
    protected ao(): boolean;
    private cr;
    provideRefValueFromJson(a: any, b: string, c: string): void;
    protected a9(): (arg1: string) => string;
    ae(a: JsonDictionaryItem): boolean;
    ab(a: JsonDictionaryItem): boolean;
    ai(a: JsonDictionaryItem): boolean;
    ac(a: JsonDictionaryItem): boolean;
    ad(a: JsonDictionaryItem): boolean;
    private b6;
    private cn;
    private co;
    private ca;
    private b8;
    private a;
    private bs;
    private av;
    private aw;
    private ax;
    private au;
    private as;
    private a0;
    get a4(): Dictionary$2<any, ContainerState>;
    private ay;
    private at;
    private ar;
    private az;
    private a1;
    private a3;
    cleanup(a: any, b: boolean): void;
    render(a: Description, b: any): void;
    private db;
    private ct;
    private c9;
    provideRefValue(a: any, b: string, c: any): void;
    removeRefValue(a: any, b: string): void;
    private c7;
    clearRefValues(a: any): void;
    private u;
    queueForIdle(a: any, b: () => void): void;
    tryFlushIdleActions(a: any): void;
    private da;
    private dd;
    private dj;
    private cm;
    private cu;
    private cv;
    private y;
    private aj;
    private aq;
    private b7;
    private b5;
    private cb;
    private an;
    private bv;
    private bq;
    private br;
    private bp;
    private bo;
    private bn;
    private bm;
    private bl;
    private bk;
    e(a: string, b: ContainerState): DescriptionRef;
    private b1;
    private bj;
    private b0;
    private bh;
    private bz;
    private b2;
    private b4;
    private bg;
    private bf;
    private be;
    private b3;
    private bd;
    private bc;
    private a7;
    addTargetPropertyUpdatingListener(a: (propertyPath: string, target: any, newValue: any) => boolean): void;
    removeTargetPropertyUpdatingListener(a: (propertyPath: string, target: any, newValue: any) => boolean): void;
    private a2;
    addPropertyUpdatingListener(a: string, b: (propertyName: string, target: any, newValue: any) => void): void;
    private a5;
    addReferenceLookupListener(a: (container: any, refType: string, id: string) => any): void;
    removeReferenceLookupListener(a: (container: any, refType: string, id: string) => any): void;
    removePropertyUpdatingListener(a: string, b: (propertyName: string, target: any, newValue: any) => void): void;
    private a6;
    addNamespaceLookupListener(a: (container: any) => string): void;
    removeNamespaceLookupListener(a: (container: any) => string): void;
    private bb;
    private dh;
    hasUserRef(a: string): boolean;
    private _shouldNamespaceSystemRefValues;
    get shouldNamespaceSystemRefValues(): boolean;
    set shouldNamespaceSystemRefValues(a: boolean);
    cx(a: any, b: string, c: any, d: boolean): void;
    removeRefValueCore(a: any, b: string, c: boolean): void;
    clearUserRefValues(): void;
    r(a: DescriptionRef): boolean;
    bx(a: DescriptionRef): any;
    q(a: string): boolean;
    f(a: string): DescriptionRef;
    getMissingRefs(): string[];
    getRefChangeInfos(a: string): DescriptionRefTargetInfo[];
    private by;
    private ah;
    private am;
    private ag;
    private dc;
    private al;
    cl(a: any, b: any, c: ContainerState): void;
    private ba;
    private af;
    private c0;
    private ak;
    private aa;
    private m;
    private cc;
    private bt;
    private v;
    private bi;
    private a8;
    private z;
    private ci;
    private di;
    private bw;
    private p;
    private o;
}
/**
 * @hidden
 */
export declare class ContainerState extends Base {
    static $t: Type;
    i: any;
    private e;
    private f;
    private d;
    private g;
    private c;
    k(a: any, b: number, c: any, d: DescriptionTreeNode, e: (arg1: any, arg2: string, arg3: any, arg4: boolean) => void, f: number): void;
    a(a: number): boolean;
    b(a: any): boolean;
    j(a: number): any;
    l(a: ComponentRenderer, b: any, c: number, d: (arg1: any, arg2: string, arg3: boolean) => void): void;
    h(a: any): number;
}
